import React, { Component } from "react";

import Counter from "./counter";

export default class App extends Component {
	constructor(props) {
		super(props);
		console.log("constructor");
		this.state = {
			counter: 0,
			id: null,
			time: new Date().toLocaleTimeString(),
			random: 0
		};
	}

	tick = () => this.setState({ time: new Date().toLocaleTimeString() });

	UNSAFE_componentWillMount() {
		console.log("componentWillMount");
	}

	static getDerivedStateFromProps(nextProps, prevState) {
		console.log("getDerivedStateFromProps");
		return null;
	}

	async componentDidMount() {
		console.log("componentDidMount");

		const id = setInterval(this.tick, 1000);
		console.log("id", id);
		this.setState({ id });
	}

	componentWillUnmount() {
		console.log("componentWillUnmount");
		clearInterval(this.state.id);
	}

	shouldComponentUpdate(nextProps, nextState, nextContext) {
		console.log("shouldComponentUpdate");
		return true;
	}

	getSnapshotBeforeUpdate(prevProps, prevState) {
		console.log("getSnapshotBeforeUpdate");
		return null;
	}

	async componentDidUpdate(prevProps, prevState, snapshot) {
		console.log("componentDidUpdate");
	}

	inc = () => this.setState(prevState => ({ counter: prevState.counter + 1 }));
	dec = () => this.setState(prevState => ({ counter: prevState.counter - 1 }));

	random = () => this.setState({ random: Math.floor(Math.random() * 10 + 1) });

	render() {
		return (
			<div>
				<button onClick={this.random}>Random</button>

				<Counter counter={this.state.counter} inc={this.inc} dec={this.dec} random={this.state.random} />

				<h1>Date now {this.state.time}</h1>
			</div>
		);
	}
}
